| AI Engine Intrinsics User Guide (v2026.1)

Loading...
Searching...
No Matches
Functions
X buffer conjugation
Intrinsics » Vector Operations » MAC intrinsics » Multiplication » Advanced » Integer » Vector MAC » 32 bit x 16 bit » 32 bit Complex x 16 bit Real

## Overview

32 bit complex by 16 bit real using X buffer conjugation

## Functions
v4cacc80 | lmac4_c (v4cacc80 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-accumulate intrinsic function with x buffer conjugation .
v4cacc80 | lmac4_c (v4cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-accumulate intrinsic function with x buffer conjugation using small X input buffer.
v4cacc80 | lmsc4_c (v4cacc80 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-subtract intrinsic function with x buffer conjugation .
v4cacc80 | lmsc4_c (v4cacc80 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-subtract intrinsic function with x buffer conjugation using small X input buffer.
v4cacc80 | lmul4_c (v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply intrinsic function with x buffer conjugation .
v4cacc80 | lmul4_c (v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply intrinsic function with x buffer conjugation using small X input buffer.
v4cacc80 | lnegmul4_c (v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-negate intrinsic function with x buffer conjugation .
v4cacc80 | lnegmul4_c (v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-negate intrinsic function with x buffer conjugation using small X input buffer.
v4cacc48 | mac4_c (v4cacc48 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-accumulate intrinsic function with x buffer conjugation .
v4cacc48 | mac4_c (v4cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-accumulate intrinsic function with x buffer conjugation using small X input buffer.
v8cacc48 | mac8_c (v8cacc48 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-accumulate intrinsic function with x buffer conjugation .
v8cacc48 | mac8_c (v8cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-accumulate intrinsic function with x buffer conjugation using small X input buffer.
v4cacc48 | msc4_c (v4cacc48 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-subtract intrinsic function with x buffer conjugation .
v4cacc48 | msc4_c (v4cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-subtract intrinsic function with x buffer conjugation using small X input buffer.
v8cacc48 | msc8_c (v8cacc48 acc, v16cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-subtract intrinsic function with x buffer conjugation .
v8cacc48 | msc8_c (v8cacc48 acc, v8cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-subtract intrinsic function with x buffer conjugation using small X input buffer.
v4cacc48 | mul4_c (v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply intrinsic function with x buffer conjugation .
v4cacc48 | mul4_c (v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply intrinsic function with x buffer conjugation using small X input buffer.
v8cacc48 | mul8_c (v16cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply intrinsic function with x buffer conjugation .
v8cacc48 | mul8_c (v8cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply intrinsic function with x buffer conjugation using small X input buffer.
v4cacc48 | negmul4_c (v16cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-negate intrinsic function with x buffer conjugation .
v4cacc48 | negmul4_c (v8cint32 xbuff, int xstart, unsigned int xoffsets, int xstep, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Complex multiply-negate intrinsic function with x buffer conjugation using small X input buffer.
v8cacc48 | negmul8_c (v16cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-negate intrinsic function with x buffer conjugation .
v8cacc48 | negmul8_c (v8cint32 xbuff, int xstart, unsigned int xoffsets, v16int16 zbuff, int zstart, unsigned int zoffsets)
| Complex multiply-negate intrinsic function with x buffer conjugation using small X input buffer.

## Function Documentation

## ◆ lmac4_c() [1/2]

v4cacc80 lmac4_c | ( | v4cacc80 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-accumulate intrinsic function with x buffer conjugation .

acc0 += z00*cnj(x00) + z01*cnj(x01)
acc1 += z10*cnj(x10) + z11*cnj(x11)
acc2 += z20*cnj(x20) + z21*cnj(x21)
acc3 += z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmac4_c() [2/2]

v4cacc80 lmac4_c | ( | v4cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-accumulate intrinsic function with x buffer conjugation using small X input buffer.

acc0 += z00*cnj(x00) + z01*cnj(x01)
acc1 += z10*cnj(x10) + z11*cnj(x11)
acc2 += z20*cnj(x20) + z21*cnj(x21)
acc3 += z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc4_c() [1/2]

v4cacc80 lmsc4_c | ( | v4cacc80 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-subtract intrinsic function with x buffer conjugation .

acc0 -= z00*cnj(x00) + z01*cnj(x01)
acc1 -= z10*cnj(x10) + z11*cnj(x11)
acc2 -= z20*cnj(x20) + z21*cnj(x21)
acc3 -= z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmsc4_c() [2/2]

v4cacc80 lmsc4_c | ( | v4cacc80 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-subtract intrinsic function with x buffer conjugation using small X input buffer.

acc0 -= z00*cnj(x00) + z01*cnj(x01)
acc1 -= z10*cnj(x10) + z11*cnj(x11)
acc2 -= z20*cnj(x20) + z21*cnj(x21)
acc3 -= z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint80 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul4_c() [1/2]

v4cacc80 lmul4_c | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply intrinsic function with x buffer conjugation .

acc0 = z00*cnj(x00) + z01*cnj(x01)
acc1 = z10*cnj(x10) + z11*cnj(x11)
acc2 = z20*cnj(x20) + z21*cnj(x21)
acc3 = z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lmul4_c() [2/2]

v4cacc80 lmul4_c | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply intrinsic function with x buffer conjugation using small X input buffer.

acc0 = z00*cnj(x00) + z01*cnj(x01)
acc1 = z10*cnj(x10) + z11*cnj(x11)
acc2 = z20*cnj(x20) + z21*cnj(x21)
acc3 = z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul4_c() [1/2]

v4cacc80 lnegmul4_c | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-negate intrinsic function with x buffer conjugation .

acc0 = -( z00*cnj(x00) + z01*cnj(x01) )
acc1 = -( z10*cnj(x10) + z11*cnj(x11) )
acc2 = -( z20*cnj(x20) + z21*cnj(x21) )
acc3 = -( z30*cnj(x30) + z31*cnj(x31) )

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ lnegmul4_c() [2/2]

v4cacc80 lnegmul4_c | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-negate intrinsic function with x buffer conjugation using small X input buffer.

acc0 = -( z00*cnj(x00) + z01*cnj(x01) )
acc1 = -( z10*cnj(x10) + z11*cnj(x11) )
acc2 = -( z20*cnj(x20) + z21*cnj(x21) )
acc3 = -( z30*cnj(x30) + z31*cnj(x31) )

Returns
  Returned accumulation vector (4 x cint80 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac4_c() [1/2]

v4cacc48 mac4_c | ( | v4cacc48 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-accumulate intrinsic function with x buffer conjugation .

acc0 += z00*cnj(x00) + z01*cnj(x01)
acc1 += z10*cnj(x10) + z11*cnj(x11)
acc2 += z20*cnj(x20) + z21*cnj(x21)
acc3 += z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac4_c() [2/2]

v4cacc48 mac4_c | ( | v4cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-accumulate intrinsic function with x buffer conjugation using small X input buffer.

acc0 += z00*cnj(x00) + z01*cnj(x01)
acc1 += z10*cnj(x10) + z11*cnj(x11)
acc2 += z20*cnj(x20) + z21*cnj(x21)
acc3 += z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac8_c() [1/2]

v8cacc48 mac8_c | ( | v8cacc48 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply-accumulate intrinsic function with x buffer conjugation .

acc0 += z00*cnj(x00)
acc1 += z10*cnj(x10)
acc2 += z20*cnj(x20)
acc3 += z30*cnj(x30)
acc4 += z40*cnj(x40)
acc5 += z50*cnj(x50)
acc6 += z60*cnj(x60)
acc7 += z70*cnj(x70)

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac8_c() [2/2]

v8cacc48 mac8_c | ( | v8cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply-accumulate intrinsic function with x buffer conjugation using small X input buffer.

acc0 += z00*cnj(x00)
acc1 += z10*cnj(x10)
acc2 += z20*cnj(x20)
acc3 += z30*cnj(x30)
acc4 += z40*cnj(x40)
acc5 += z50*cnj(x50)
acc6 += z60*cnj(x60)
acc7 += z70*cnj(x70)

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc4_c() [1/2]

v4cacc48 msc4_c | ( | v4cacc48 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-subtract intrinsic function with x buffer conjugation .

acc0 -= z00*cnj(x00) + z01*cnj(x01)
acc1 -= z10*cnj(x10) + z11*cnj(x11)
acc2 -= z20*cnj(x20) + z21*cnj(x21)
acc3 -= z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc4_c() [2/2]

v4cacc48 msc4_c | ( | v4cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-subtract intrinsic function with x buffer conjugation using small X input buffer.

acc0 -= z00*cnj(x00) + z01*cnj(x01)
acc1 -= z10*cnj(x10) + z11*cnj(x11)
acc2 -= z20*cnj(x20) + z21*cnj(x21)
acc3 -= z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (4 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc8_c() [1/2]

v8cacc48 msc8_c | ( | v8cacc48 | acc,
|  | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply-subtract intrinsic function with x buffer conjugation .

acc0 -= z00*cnj(x00)
acc1 -= z10*cnj(x10)
acc2 -= z20*cnj(x20)
acc3 -= z30*cnj(x30)
acc4 -= z40*cnj(x40)
acc5 -= z50*cnj(x50)
acc6 -= z60*cnj(x60)
acc7 -= z70*cnj(x70)

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc8_c() [2/2]

v8cacc48 msc8_c | ( | v8cacc48 | acc,
|  | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply-subtract intrinsic function with x buffer conjugation using small X input buffer.

acc0 -= z00*cnj(x00)
acc1 -= z10*cnj(x10)
acc2 -= z20*cnj(x20)
acc3 -= z30*cnj(x30)
acc4 -= z40*cnj(x40)
acc5 -= z50*cnj(x50)
acc6 -= z60*cnj(x60)
acc7 -= z70*cnj(x70)

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x cint48 lanes)
  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul4_c() [1/2]

v4cacc48 mul4_c | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply intrinsic function with x buffer conjugation .

acc0 = z00*cnj(x00) + z01*cnj(x01)
acc1 = z10*cnj(x10) + z11*cnj(x11)
acc2 = z20*cnj(x20) + z21*cnj(x21)
acc3 = z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul4_c() [2/2]

v4cacc48 mul4_c | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply intrinsic function with x buffer conjugation using small X input buffer.

acc0 = z00*cnj(x00) + z01*cnj(x01)
acc1 = z10*cnj(x10) + z11*cnj(x11)
acc2 = z20*cnj(x20) + z21*cnj(x21)
acc3 = z30*cnj(x30) + z31*cnj(x31)

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul8_c() [1/2]

v8cacc48 mul8_c | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply intrinsic function with x buffer conjugation .

acc0 = z00*cnj(x00)
acc1 = z10*cnj(x10)
acc2 = z20*cnj(x20)
acc3 = z30*cnj(x30)
acc4 = z40*cnj(x40)
acc5 = z50*cnj(x50)
acc6 = z60*cnj(x60)
acc7 = z70*cnj(x70)

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul8_c() [2/2]

v8cacc48 mul8_c | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply intrinsic function with x buffer conjugation using small X input buffer.

acc0 = z00*cnj(x00)
acc1 = z10*cnj(x10)
acc2 = z20*cnj(x20)
acc3 = z30*cnj(x30)
acc4 = z40*cnj(x40)
acc5 = z50*cnj(x50)
acc6 = z60*cnj(x60)
acc7 = z70*cnj(x70)

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul4_c() [1/2]

v4cacc48 negmul4_c | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-negate intrinsic function with x buffer conjugation .

acc0 = -( z00*cnj(x00) + z01*cnj(x01) )
acc1 = -( z10*cnj(x10) + z11*cnj(x11) )
acc2 = -( z20*cnj(x20) + z21*cnj(x21) )
acc3 = -( z30*cnj(x30) + z31*cnj(x31) )

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul4_c() [2/2]

v4cacc48 negmul4_c | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep )

Complex multiply-negate intrinsic function with x buffer conjugation using small X input buffer.

acc0 = -( z00*cnj(x00) + z01*cnj(x01) )
acc1 = -( z10*cnj(x10) + z11*cnj(x11) )
acc2 = -( z20*cnj(x20) + z21*cnj(x21) )
acc3 = -( z30*cnj(x30) + z31*cnj(x31) )

Returns
  Returned accumulation vector (4 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer.
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul8_c() [1/2]

v8cacc48 negmul8_c | ( | v16cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply-negate intrinsic function with x buffer conjugation .

acc0 = -( z00*cnj(x00) )
acc1 = -( z10*cnj(x10) )
acc2 = -( z20*cnj(x20) )
acc3 = -( z30*cnj(x30) )
acc4 = -( z40*cnj(x40) )
acc5 = -( z50*cnj(x50) )
acc6 = -( z60*cnj(x60) )
acc7 = -( z70*cnj(x70) )

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 16 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul8_c() [2/2]

v8cacc48 negmul8_c | ( | v8cint32 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets )

Complex multiply-negate intrinsic function with x buffer conjugation using small X input buffer.

acc0 = -( z00*cnj(x00) )
acc1 = -( z10*cnj(x10) )
acc2 = -( z20*cnj(x20) )
acc3 = -( z30*cnj(x30) )
acc4 = -( z40*cnj(x40) )
acc5 = -( z50*cnj(x50) )
acc6 = -( z60*cnj(x60) )
acc7 = -( z70*cnj(x70) )

Returns
  Returned accumulation vector (8 x cint48 lanes)

Parameters

  xbuff | Input buffer of 8 elements of type cint32
  xstart | Starting position offset applied to all lanes of input from X buffer.
  xoffsets | 4b offset for each lane, applied to the x buffer. LSB apply to first lane
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane

Note
  - For more information on how data selection works from the buffers go here. The data buffer and coefficient buffer in this intrinsic use the general scheme.
  - Parameter 'zstart' must be a compile time constant.